

from datetime import datetime
import requests as rq

import json

#  how many last records load from each saved device
pages_offset = 0 # number of pages from the newest which are not going to be loaded
n_of_pages = 10 # n of records to load
page_size = 250 # max 250

output_directory = "dataFromLoratech"
# source files off given device
# dir/file without extension (has to be csv)
filename = {
    "Příjezd" : "vjezd", #.csv 
    "Průjezd" : "prujezd", # .csv
    "Odjezd" : "odjezd"} # .csv
    
dev_euids = {
    "Příjezd" : "0004a30b00f95816",
    "Průjezd" : "0004a30b00f8ca27",
    "Odjezd" : "0004a30b00f95348"
}

login_url = "https://test.loratech.cz/api/v2/login"

data_url_part1 = "https://test.loratech.cz/api/v2/nodes/"
data_url_part2 = "/data"


login_loratech = "sciot-parking@ket.zcu.cz"
password_loratech = "Sciot-Park-1"


def getLoginToken(url, login, password):
    data = { "email": login, "password": password }
    request = rq.post(url, data = data)  
    
    try:
        return request.json()['token']
    except:
        return "INVALID"


def getRequestRecords(url, token, pageNumber, pageSize):

    headers = {"Authorization": "Bearer %s" % token, "Content-Type" : "application/x-www-form-urlencoded"}
    print("GET :" + str(url) + "?perPage=" + str(pageSize) + "&page=" + str(pageNumber))
    request = rq.get(str(url) + "?perPage=" + str(pageSize) + "&page=" + str(pageNumber), headers = headers)
    try:
        return json.loads(request.text)
    except:
        return {}

def getRecords(url, token, pageOffset, nOfPages, pageSize):
    
    output = []

    for i in range(pageOffset, pageOffset + nOfPages):
        output = output + getRequestRecords(url, token, i, pageSize)['data']
    return output

def writeToFile(recordsList, filename):

    with open(filename, "w+") as file:
        for record in recordsList:
            for key in record :
                file.write(str(record[key]) + ";")
            file.write("\n")
    file.close()


# just calling the main function
if __name__ == "__main__":
    login_token = getLoginToken(login_url, login_loratech, password_loratech)
    if(login_token == "INVALID"):
        print("invalid login credentials")
        exit()
    
    for key in dev_euids:
        print("getting " + key + ":" + dev_euids[key])
        
        records = getRecords(data_url_part1 + dev_euids[key] + data_url_part2, login_token, pages_offset, n_of_pages, page_size)
        writeToFile(records, output_directory + "/" + filename[key] + ".csv")



