from asyncio.windows_events import NULL
import datetime
import json
from utils import *

# time range from processed files
start_date = "17-05-2022" # dd-mm-YYYY
end_date = "20-05-2022"   # dd-mm-YYYY

# source files off given device
# dir/file without extension (has to be csv)
filename = {
    "Příjezd" : "vjezd", #.csv 
    "Průjezd" : "prujezd", # .csv
    "Odjezd" : "odjezd"} # .csv

input_directory = 'dataFromLoratech/'
output_directory = 'dataProcessed/'

# function prcoessing new entry
def getProcessedLine(dateTimeNow, dateTimePrevious, parsedDataNEW, parsedDataPrevious, summaries_dictionary):

    # assignment of missing variables
    if('len0_speed0_cnt12' not in parsedDataNEW):
        parsedDataNEW['len0_speed0_cnt12'] = 0
    if('len0_speed1_cnt12' not in parsedDataNEW):
        parsedDataNEW['len0_speed1_cnt12'] = 0
    if('len0_speed2_cnt12' not in parsedDataNEW):
        parsedDataNEW['len0_speed2_cnt12'] = 0
    if('len0_speed3_cnt12' not in parsedDataNEW):
        parsedDataNEW['len0_speed3_cnt12'] = 0
    if('len1_speed0_cnt12' not in parsedDataNEW):
        parsedDataNEW['len1_speed0_cnt12'] = 0
    if('len1_speed1_cnt12' not in parsedDataNEW):
        parsedDataNEW['len1_speed1_cnt12'] = 0
    if('len1_speed2_cnt12' not in parsedDataNEW):
        parsedDataNEW['len1_speed2_cnt12'] = 0
    if('len1_speed3_cnt12' not in parsedDataNEW):
        parsedDataNEW['len1_speed3_cnt12'] = 0
    if('len2_speed0_cnt12' not in parsedDataNEW):
        parsedDataNEW['len2_speed0_cnt12'] = 0
    if('len2_speed1_cnt12' not in parsedDataNEW):
        parsedDataNEW['len2_speed1_cnt12'] = 0
    if('len2_speed2_cnt12' not in parsedDataNEW):
        parsedDataNEW['len2_speed2_cnt12'] = 0
    if('len2_speed3_cnt12' not in parsedDataNEW):
        parsedDataNEW['len2_speed3_cnt12'] = 0
    if('len3_cnt12' not in parsedDataNEW):
        parsedDataNEW['len3_cnt12'] = 0

    if('len0_speed0_cnt12' not in parsedDataPrevious):
       parsedDataPrevious['len0_speed0_cnt12'] = 0
    if('len0_speed1_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len0_speed1_cnt12'] = 0
    if('len0_speed2_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len0_speed2_cnt12'] = 0
    if('len0_speed3_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len0_speed3_cnt12'] = 0
    if('len1_speed0_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len1_speed0_cnt12'] = 0
    if('len1_speed1_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len1_speed1_cnt12'] = 0
    if('len1_speed2_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len1_speed2_cnt12'] = 0
    if('len1_speed3_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len1_speed3_cnt12'] = 0
    if('len2_speed0_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len2_speed0_cnt12'] = 0
    if('len2_speed1_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len2_speed1_cnt12'] = 0
    if('len2_speed2_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len2_speed2_cnt12'] = 0
    if('len2_speed3_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len2_speed3_cnt12'] = 0
    if('len3_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len3_cnt12'] = 0

    # repair of values IN CASE OF other value OWERFLOW
    if(parsedDataNEW['len0_speed0_cnt12'] < parsedDataPrevious['len0_speed0_cnt12']):
        parsedDataNEW['len0_speed0_cnt12'] = parsedDataNEW['len0_speed0_cnt12'] + 4096
    if(parsedDataNEW['len0_speed1_cnt12'] < parsedDataPrevious['len0_speed1_cnt12']):
        parsedDataNEW['len0_speed1_cnt12'] = parsedDataNEW['len0_speed1_cnt12'] + 4096
    if(parsedDataNEW['len0_speed2_cnt12'] < parsedDataPrevious['len0_speed2_cnt12']):
        parsedDataNEW['len0_speed2_cnt12'] = parsedDataNEW['len0_speed2_cnt12'] + 4096
    if(parsedDataNEW['len0_speed3_cnt12'] < parsedDataPrevious['len0_speed3_cnt12']):
        parsedDataNEW['len0_speed3_cnt12'] = parsedDataNEW['len0_speed3_cnt12'] + 4096

    if(parsedDataNEW['len1_speed0_cnt12'] < parsedDataPrevious['len1_speed0_cnt12']):
       parsedDataNEW['len1_speed0_cnt12'] = parsedDataNEW['len1_speed0_cnt12'] + 4096
    if(parsedDataNEW['len1_speed1_cnt12'] < parsedDataPrevious['len1_speed1_cnt12']):
        parsedDataNEW['len1_speed1_cnt12'] = parsedDataNEW['len1_speed1_cnt12'] + 4096
    if(parsedDataNEW['len1_speed2_cnt12'] < parsedDataPrevious['len1_speed2_cnt12']):
        parsedDataNEW['len1_speed2_cnt12'] = parsedDataNEW['len1_speed2_cnt12'] + 4096
    if(parsedDataNEW['len1_speed3_cnt12'] < parsedDataPrevious['len1_speed3_cnt12']):
        parsedDataNEW['len1_speed3_cnt12'] = parsedDataNEW['len1_speed3_cnt12'] + 4096

    if(parsedDataNEW['len2_speed0_cnt12'] < parsedDataPrevious['len2_speed0_cnt12']):
        parsedDataNEW['len2_speed0_cnt12'] = parsedDataNEW['len2_speed0_cnt12'] + 4096
    if(parsedDataNEW['len2_speed1_cnt12'] < parsedDataPrevious['len2_speed1_cnt12']):
        parsedDataNEW['len2_speed1_cnt12'] = parsedDataNEW['len2_speed1_cnt12'] + 4096
    if(parsedDataNEW['len2_speed2_cnt12'] < parsedDataPrevious['len2_speed2_cnt12']):
        parsedDataNEW['len2_speed2_cnt12'] = parsedDataNEW['len2_speed2_cnt12'] + 4096
    if(parsedDataNEW['len2_speed3_cnt12'] < parsedDataPrevious['len2_speed3_cnt12']):
        parsedDataNEW['len2_speed3_cnt12'] = parsedDataNEW['len2_speed3_cnt12'] + 4096

    if(parsedDataNEW['len3_cnt12'] < parsedDataPrevious['len3_cnt12']):
        parsedDataNEW['len3_cnt12'] = parsedDataNEW['len3_cnt12'] + 4096
    

    new_len0_count = - parsedDataNEW['len0_speed0_cnt12'] + parsedDataNEW['len0_speed1_cnt12'] + parsedDataNEW['len0_speed2_cnt12'] +parsedDataNEW['len0_speed3_cnt12']
    new_len1_count = - parsedDataNEW['len1_speed0_cnt12'] + parsedDataNEW['len1_speed1_cnt12'] + parsedDataNEW['len1_speed2_cnt12'] +parsedDataNEW['len1_speed3_cnt12']
    new_len2_count = - parsedDataNEW['len2_speed0_cnt12'] + parsedDataNEW['len2_speed1_cnt12'] + parsedDataNEW['len2_speed2_cnt12'] +parsedDataNEW['len2_speed3_cnt12']


    old_len0_count = - parsedDataPrevious['len0_speed0_cnt12'] + parsedDataPrevious['len0_speed1_cnt12'] + parsedDataPrevious['len0_speed2_cnt12'] +parsedDataPrevious['len0_speed3_cnt12']
    old_len1_count = - parsedDataPrevious['len1_speed0_cnt12'] + parsedDataPrevious['len1_speed1_cnt12'] + parsedDataPrevious['len1_speed2_cnt12'] +parsedDataPrevious['len1_speed3_cnt12']
    old_len2_count = - parsedDataPrevious['len2_speed0_cnt12'] + parsedDataPrevious['len2_speed1_cnt12'] + parsedDataPrevious['len2_speed2_cnt12'] +parsedDataPrevious['len2_speed3_cnt12']

    new_len3_count = parsedDataNEW['len3_cnt12']
    old_len3_count = parsedDataPrevious['len3_cnt12']

    new_speed0_count = parsedDataNEW['len0_speed0_cnt12'] + parsedDataNEW['len1_speed0_cnt12'] + parsedDataNEW['len2_speed0_cnt12'] +  parsedDataNEW['len3_cnt12']
    new_speed1_count = parsedDataNEW['len0_speed1_cnt12'] + parsedDataNEW['len1_speed1_cnt12'] + parsedDataNEW['len2_speed1_cnt12'] +  parsedDataNEW['len3_cnt12']
    new_speed2_count = parsedDataNEW['len0_speed2_cnt12'] + parsedDataNEW['len1_speed2_cnt12'] + parsedDataNEW['len2_speed2_cnt12'] +  parsedDataNEW['len3_cnt12']
    new_speed3_count = parsedDataNEW['len0_speed3_cnt12'] + parsedDataNEW['len1_speed3_cnt12'] + parsedDataNEW['len2_speed3_cnt12'] +  parsedDataNEW['len3_cnt12']

    old_speed0_count = parsedDataPrevious['len0_speed0_cnt12'] + parsedDataPrevious['len1_speed0_cnt12'] + parsedDataPrevious['len2_speed0_cnt12'] +  parsedDataPrevious['len3_cnt12']
    old_speed1_count = parsedDataPrevious['len0_speed1_cnt12'] + parsedDataPrevious['len1_speed1_cnt12'] + parsedDataPrevious['len2_speed1_cnt12'] +  parsedDataPrevious['len3_cnt12']
    old_speed2_count = parsedDataPrevious['len0_speed2_cnt12'] + parsedDataPrevious['len1_speed2_cnt12'] + parsedDataPrevious['len2_speed2_cnt12'] +  parsedDataPrevious['len3_cnt12']
    old_speed3_count = parsedDataPrevious['len0_speed3_cnt12'] + parsedDataPrevious['len1_speed3_cnt12'] + parsedDataPrevious['len2_speed3_cnt12'] +  parsedDataPrevious['len3_cnt12']


    year_string = dateTimeNow[0:4]
    day_string = dateTimeNow[8:10]
    hour_string = dateTimeNow[11:13]
    month_string = dateTimeNow[5:7]
    week_string = week_number_of_month(int(day_string),int(month_string), int(year_string))
    
    day_key = "%sm_%sd" % (month_string, day_string) 
    week_key = "%sw" % (week_string) 
    month_key = ("%sm" % (month_string))  
    hour_key = "%sh" % (hour_string) 


    if(day_key not in summaries_dictionary["day"]):
        summaries_dictionary["day"][day_key] = {

                "hour" : {},

                "index_in_day" : 0,
                #"speed0_diff"
                "protismer_den" : 0,
                #"speed1_diff"
                "do_40_kmh_den" : 0,
                # "speed2_diff"
                "40_az_60_kmh_den" : 0,
                #"speed3_diff"
                "vice_nez_60_kmh_den" : 0,
                #"len0_diff"
                "osobni_auto_den": 0,
                #"len1_diff"
                "dodavka_den": 0, 
                #"len2_diff"
                "nakladni_auto_den": 0,
                #"len3_diff"
                "nerozeznane_vozidlo_den" : 0
        }
    if(hour_key not in summaries_dictionary["day"][day_key]["hour"]):
        summaries_dictionary["day"][day_key]["hour"][hour_key] = {
                "index_in_hour" : 0,
                #"speed0_diff"
                "protismer_hodina" : 0,
                #"speed1_diff"
                "do_40_kmh_hodina" : 0,
                # "speed2_diff"
                "40_az_60_kmh_hodina" : 0,
                #"speed3_diff"
                "vice_nez_60_kmh_hodina" : 0,
                #"len0_diff"
                "osobni_auto_hodina": 0,
                #"len1_diff"
                "dodavka_hodina": 0, 
                #"len2_diff"
                "nakladni_auto_hodina": 0,
                #"len3_diff"
                "nerozeznane_vozidlo_hodina" : 0
        }

    if(week_key not in summaries_dictionary["week"]):
        summaries_dictionary["week"][week_key] =  {
                "index_in_week" : 0,
                #"speed0_diff"
                "protismer_tyden" : 0,
                #"speed1_diff"
                "do_40_kmh_tyden" : 0,
                # "speed2_diff"
                "40_az_60_kmh_tyden" : 0,
                #"speed3_diff"
                "vice_nez_60_kmh_tyden" : 0,
                #"len0_diff"
                "osobni_auto_tyden": 0,
                #"len1_diff"
                "dodavka_tyden": 0, 
                #"len2_diff"
                "nakladni_auto_tyden": 0,
                #"len3_diff"
                "nerozeznane_vozidlo_tyden" : 0
        }
    if(month_key not in summaries_dictionary["month"]):
        summaries_dictionary["month"][month_key] =  {
                "index_in_month" : 0,
                #"speed0_diff"
                "protismer_mesic" : 0,
                #"speed1_diff"
                "do_40_kmh_mesic" : 0,
                # "speed2_diff"
                "40_az_60_kmh_mesic" : 0,
                #"speed3_diff"
                "vice_nez_60_kmh_mesic" : 0,
                #"len0_diff"
                "osobni_auto_mesic": 0,
                #"len1_diff"
                "dodavka_mesic": 0, 
                #"len2_diff"
                "nakladni_auto_mesic": 0,
                #"len3_diff"
                "nerozeznane_vozidlo_mesic" : 0
        }

    # data object
    data = {
        "stime": dateTimeNow,
        "data": {

             ### TIME RANGE:
                "time_range_begin" : dateTimePrevious,
                "time_range_end" : dateTimeNow,

                #"speed0_diff"
                "protismer" : new_speed0_count - old_speed0_count,
                #"speed1_diff"
                "do_40_kmh" : new_speed1_count - old_speed1_count,
                # "speed2_diff"
                "40_az_60_kmh" : new_speed2_count - old_speed2_count,
                #"speed3_diff"
                "vice_nez_60_kmh" : new_speed3_count - old_speed3_count,
                #"len0_diff"
                "osobni_auto": new_len0_count - old_len0_count,
                #"len1_diff"
                "dodavka": new_len1_count - old_len1_count, 
                #"len2_diff"
                "nakladni_auto": new_len2_count - old_len2_count,
                #"len3_diff"
                "nerozeznane_vozidlo" : new_len3_count - old_len3_count, 

            ### tento den sum:
                "index_in_day" : summaries_dictionary["day"][day_key]["index_in_day"] + 1,

                #"speed0_diff"
                "protismer_den" : summaries_dictionary["day"][day_key]["protismer_den"] + (new_speed0_count - old_speed0_count),
                #"speed1_diff"
                "do_40_kmh_den" : summaries_dictionary["day"][day_key]["do_40_kmh_den"] + (new_speed1_count - old_speed1_count),
                # "speed2_diff"
                "40_az_60_kmh_den" : summaries_dictionary["day"][day_key]["40_az_60_kmh_den"] + (new_speed2_count - old_speed2_count),
                #"speed3_diff"
                "vice_nez_60_kmh_den" : summaries_dictionary["day"][day_key]["vice_nez_60_kmh_den"] + (new_speed3_count - old_speed3_count),
                #"len0_diff"
                "osobni_auto_den": summaries_dictionary["day"][day_key]["osobni_auto_den"] + (new_len0_count - old_len0_count),
                #"len1_diff"
                "dodavka_den": summaries_dictionary["day"][day_key]["dodavka_den"] + (new_len1_count - old_len1_count), 
                #"len2_diff"
                "nakladni_auto_den": summaries_dictionary["day"][day_key]["nakladni_auto_den"] + (new_len2_count - old_len2_count),
                #"len3_diff"
                "nerozeznane_vozidlo_den" : summaries_dictionary["day"][day_key]["nerozeznane_vozidlo_den"] + (new_len3_count - old_len3_count), 

                "index_in_day" : summaries_dictionary["day"][day_key]["index_in_day"] + 1,

                #"speed0_diff"

                "index_in_hour" : summaries_dictionary["day"][day_key]["hour"][hour_key]["index_in_hour"] + 1,

                "protismer_hodina" : summaries_dictionary["day"][day_key]["hour"][hour_key]["protismer_hodina"] + (new_speed0_count - old_speed0_count),
                #"speed1_diff"
                "do_40_kmh_hodina" : summaries_dictionary["day"][day_key]["hour"][hour_key]["do_40_kmh_hodina"] + (new_speed1_count - old_speed1_count),
                # "speed2_diff"
                "40_az_60_kmh_hodina" : summaries_dictionary["day"][day_key]["hour"][hour_key]["40_az_60_kmh_hodina"] + (new_speed2_count - old_speed2_count),
                #"speed3_diff"
                "vice_nez_60_kmh_hodina" : summaries_dictionary["day"][day_key]["hour"][hour_key]["vice_nez_60_kmh_hodina"] + (new_speed3_count - old_speed3_count),
                #"len0_diff"
                "osobni_auto_hodina": summaries_dictionary["day"][day_key]["hour"][hour_key]["osobni_auto_hodina"] + (new_len0_count - old_len0_count),
                #"len1_diff"
                "dodavka_hodina": summaries_dictionary["day"][day_key]["hour"][hour_key]["dodavka_hodina"] + (new_len1_count - old_len1_count), 
                #"len2_diff"
                "nakladni_auto_hodina": summaries_dictionary["day"][day_key]["hour"][hour_key]["nakladni_auto_hodina"] + (new_len2_count - old_len2_count),
                #"len3_diff"
                "nerozeznane_vozidlo_hodina" : summaries_dictionary["day"][day_key]["hour"][hour_key]["nerozeznane_vozidlo_hodina"] + (new_len3_count - old_len3_count), 

            ### tento tyden sum:
                "index_in_week" : summaries_dictionary["week"][week_key]["index_in_week"] + 1,

                #"speed0_diff"
                "protismer_tyden" : summaries_dictionary["week"][week_key]["protismer_tyden"] + (new_speed0_count - old_speed0_count),
                #"speed1_diff"
                "do_40_kmh_tyden" : summaries_dictionary["week"][week_key]["do_40_kmh_tyden"] + (new_speed1_count - old_speed1_count),
                # "speed2_diff"
                "40_az_60_kmh_tyden" : summaries_dictionary["week"][week_key]["40_az_60_kmh_tyden"] + (new_speed2_count - old_speed2_count),
                #"speed3_diff"
                "vice_nez_60_kmh_tyden" : summaries_dictionary["week"][week_key]["vice_nez_60_kmh_tyden"] + (new_speed3_count - old_speed3_count),
                #"len0_diff"
                "osobni_auto_tyden": summaries_dictionary["week"][week_key]["osobni_auto_tyden"] + (new_len0_count - old_len0_count),
                #"len1_diff"
                "dodavka_tyden": summaries_dictionary["week"][week_key]["dodavka_tyden"] + (new_len1_count - old_len1_count), 
                #"len2_diff"
                "nakladni_auto_tyden": summaries_dictionary["week"][week_key]["nakladni_auto_tyden"] + (new_len2_count - old_len2_count),
                #"len3_diff"
                "nerozeznane_vozidlo_tyden" : summaries_dictionary["week"][week_key]["nerozeznane_vozidlo_tyden"] + (new_len3_count - old_len3_count), 

            ### tento mesic sum:
                "index_in_month" :  summaries_dictionary["month"][month_key]["index_in_month"] + 1,

                #"speed0_diff"
                "protismer_mesic" : summaries_dictionary["month"][month_key]["protismer_mesic"] + (new_speed0_count - old_speed0_count),
                #"speed1_diff"
                "do_40_kmh_mesic" : summaries_dictionary["month"][month_key]["do_40_kmh_mesic"] + (new_speed1_count - old_speed1_count),
                # "speed2_diff"
                "40_az_60_kmh_mesic" : summaries_dictionary["month"][month_key]["40_az_60_kmh_mesic"] + (new_speed2_count - old_speed2_count),
                #"speed3_diff"
                "vice_nez_60_kmh_mesic" : summaries_dictionary["month"][month_key]["vice_nez_60_kmh_mesic"] + (new_speed3_count - old_speed3_count),
                #"len0_diff"
                "osobni_auto_mesic": summaries_dictionary["month"][month_key]["osobni_auto_mesic"] + (new_len0_count - old_len0_count),
                #"len1_diff"
                "dodavka_mesic": summaries_dictionary["month"][month_key]["dodavka_mesic"] + (new_len1_count - old_len1_count), 
                #"len2_diff"
                "nakladni_auto_mesic": summaries_dictionary["month"][month_key]["nakladni_auto_mesic"] + (new_len2_count - old_len2_count),
                #"len3_diff"
                "nerozeznane_vozidlo_mesic" :  summaries_dictionary["month"][month_key]["nerozeznane_vozidlo_mesic"] + (new_len3_count - old_len3_count), 

                },
        "desc": "parkoviště FEL v.2"
    }

    summaries_dictionary["day"][day_key]["index_in_day"]  = data['data']['index_in_day']
    summaries_dictionary["day"][day_key]["protismer_den"]  = data['data']['protismer_den']
    summaries_dictionary["day"][day_key]["do_40_kmh_den"]  = data['data']['do_40_kmh_den']
    summaries_dictionary["day"][day_key]["40_az_60_kmh_den"]  = data['data']['40_az_60_kmh_den']
    summaries_dictionary["day"][day_key]["vice_nez_60_kmh_den"]  = data['data']['vice_nez_60_kmh_den']
    summaries_dictionary["day"][day_key]["osobni_auto_den"]  = data['data']['osobni_auto_den']
    summaries_dictionary["day"][day_key]["dodavka_den"]  = data['data']['dodavka_den']
    summaries_dictionary["day"][day_key]["nakladni_auto_den"]  = data['data']['nakladni_auto_den']
    summaries_dictionary["day"][day_key]["nerozeznane_vozidlo_den"] = data['data']['nerozeznane_vozidlo_den']

    # hours:
    summaries_dictionary["day"][day_key]["hour"][hour_key]["protismer_hodina"]  = data['data']['protismer_hodina']
    summaries_dictionary["day"][day_key]["hour"][hour_key]["do_40_kmh_hodina"]  = data['data']['do_40_kmh_hodina']
    summaries_dictionary["day"][day_key]["hour"][hour_key]["40_az_60_kmh_hodina"]  = data['data']['40_az_60_kmh_hodina']
    summaries_dictionary["day"][day_key]["hour"][hour_key]["vice_nez_60_kmh_hodina"]  = data['data']['vice_nez_60_kmh_hodina']
    summaries_dictionary["day"][day_key]["hour"][hour_key]["osobni_auto_hodina"]  = data['data']['osobni_auto_hodina']
    summaries_dictionary["day"][day_key]["hour"][hour_key]["dodavka_hodina"]  = data['data']['dodavka_hodina']
    summaries_dictionary["day"][day_key]["hour"][hour_key]["nakladni_auto_hodina"]  = data['data']['nakladni_auto_hodina']
    summaries_dictionary["day"][day_key]["hour"][hour_key]["nerozeznane_vozidlo_hodina"] = data['data']['nerozeznane_vozidlo_hodina']

    summaries_dictionary["week"][week_key]["index_in_week"]  = data['data']['index_in_week']
    summaries_dictionary["week"][week_key]["protismer_tyden"]  = data['data']['protismer_tyden']
    summaries_dictionary["week"][week_key]["do_40_kmh_tyden"]  = data['data']['do_40_kmh_tyden']
    summaries_dictionary["week"][week_key]["40_az_60_kmh_tyden"]  = data['data']['40_az_60_kmh_tyden']
    summaries_dictionary["week"][week_key]["vice_nez_60_kmh_tyden"]  = data['data']['vice_nez_60_kmh_tyden']
    summaries_dictionary["week"][week_key]["osobni_auto_tyden"]  = data['data']['osobni_auto_tyden']
    summaries_dictionary["week"][week_key]["dodavka_tyden"]  = data['data']['dodavka_tyden']
    summaries_dictionary["week"][week_key]["nakladni_auto_tyden"]  = data['data']['nakladni_auto_tyden']
    summaries_dictionary["week"][week_key]["nerozeznane_vozidlo_tyden"] = data['data']['nerozeznane_vozidlo_tyden']

    summaries_dictionary["month"][month_key]["index_in_month"]  = data['data']['index_in_month']
    summaries_dictionary["month"][month_key]["protismer_mesic"]  = data['data']['protismer_mesic']
    summaries_dictionary["month"][month_key]["do_40_kmh_mesic"]  = data['data']['do_40_kmh_mesic']
    summaries_dictionary["month"][month_key]["40_az_60_kmh_mesic"]  = data['data']['40_az_60_kmh_mesic']
    summaries_dictionary["month"][month_key]["vice_nez_60_kmh_mesic"]  = data['data']['vice_nez_60_kmh_mesic']
    summaries_dictionary["month"][month_key]["osobni_auto_mesic"]  = data['data']['osobni_auto_mesic']
    summaries_dictionary["month"][month_key]["dodavka_mesic"]  = data['data']['dodavka_mesic']
    summaries_dictionary["month"][month_key]["nakladni_auto_mesic"]  = data['data']['nakladni_auto_mesic']
    summaries_dictionary["month"][month_key]["nerozeznane_vozidlo_mesic"] = data['data']['nerozeznane_vozidlo_mesic']

    return "csv-line;"
    
# MAIN FUNCTION
def main():

    processed_data = {
                "Příjezd" : [], 
                "Průjezd" : [],
                "Odjezd" : []
                }


    start_datetime = datetime.datetime( int(start_date[6:10],), int(start_date[3:5]), int(start_date[0:2]))
    end_datetime = datetime.datetime( int(end_date[6:10],), int(end_date[3:5]), int(end_date[0:2]))

    new_parser_date_time = datetime.datetime(2022, 5, 1 )

    for key in filename:
        

        with open(input_directory + filename[key] + '.csv') as file:

            while line := file.readline():
                current_line = line.rstrip()
                data_part = NULL
                time = current_line.split(';')[0]

                entrance_datetime =  datetime.datetime( int(time[0:4]), int(time[5:7]), int(time[8:10]))
                


                if(entrance_datetime >= new_parser_date_time):
                    data_part = parseData(current_line.split(';')[6])
                else:
                    data_part = oldParseData(current_line.split(';')[6])

                if('part' in data_part and data_part['part'] == 1 and entrance_datetime >= start_datetime and entrance_datetime <= end_datetime):
                   processed_data[key].append({"time" : time, "data" : json.dumps(data_part)})
        
        file.close()

    for key in filename:

        summaries_dictionary = {
            "day" : {},
            "week" : {},
            "month" : {},
        }

        length = len(processed_data[key])
        for i in range(0, length - 1):  
            

            the_second_last = processed_data[key][length-1 - i]
            the_last = processed_data[key][length-1 - i - 1]
            getProcessedLine(the_last['time'], the_second_last['time'], json.loads(the_last['data']), json.loads(the_second_last['data']), summaries_dictionary)

        with open(output_directory + filename[key] + '_dny.csv', 'w') as newfile:
            #newfile.write(json.dumps(summaries_dictionary))    
            newfile.write("key;protismer_den;do_40_kmh_den;40_az_60_kmh_den;vice_nez_60_kmh_den;osobni_auto_den;dodavka_den;nakladni_auto_den;nerozeznane_vozidlo_den;auta_suma;\n")

            for summary_key in summaries_dictionary["day"]:
                celkem_aut = summaries_dictionary["day"][summary_key]['osobni_auto_den']+ summaries_dictionary["day"][summary_key]['dodavka_den']  + summaries_dictionary["day"][summary_key]['nakladni_auto_den'] + summaries_dictionary["day"][summary_key]['nerozeznane_vozidlo_den']
                newfile.write(summary_key[4:6]+'.'+summary_key[0:2]+'.'+';'+str(summaries_dictionary["day"][summary_key]['protismer_den'])+';'+str(summaries_dictionary["day"][summary_key]['do_40_kmh_den']) + ';'+str(summaries_dictionary["day"][summary_key]['40_az_60_kmh_den'])+';'+str(summaries_dictionary["day"][summary_key]['vice_nez_60_kmh_den'])+';'+str(summaries_dictionary["day"][summary_key]['osobni_auto_den'])+';'+str(summaries_dictionary["day"][summary_key]['dodavka_den'])+';'+str(summaries_dictionary["day"][summary_key]['nakladni_auto_den']) + ';'+str(summaries_dictionary["day"][summary_key]['nerozeznane_vozidlo_den']) + ';' + str(celkem_aut) + ';\n')

        with open(output_directory + filename[key] + '_tyden.csv', 'w') as newfile:
            #newfile.write(json.dumps(summaries_dictionary))    
            newfile.write("key;protismer_tyden;do_40_kmh_tyden;40_az_60_kmh_tyden;vice_nez_60_kmh_tyden;osobni_auto_tyden;dodavka_tyden;nakladni_auto_tyden;nerozeznane_vozidlo_tyden;auta_suma;\n")

            for summary_key in summaries_dictionary["week"]:
                celkem_aut = summaries_dictionary["week"][summary_key]['osobni_auto_tyden']+ summaries_dictionary["week"][summary_key]['dodavka_tyden']  + summaries_dictionary["week"][summary_key]['nakladni_auto_tyden'] + summaries_dictionary["week"][summary_key]['nerozeznane_vozidlo_tyden']
                newfile.write(summary_key+';'+str(summaries_dictionary["week"][summary_key]['protismer_tyden'])+';'+str(summaries_dictionary["week"][summary_key]['do_40_kmh_tyden']) + ';'+str(summaries_dictionary["week"][summary_key]['40_az_60_kmh_tyden'])+';'+str(summaries_dictionary["week"][summary_key]['vice_nez_60_kmh_tyden'])+';'+str(summaries_dictionary["week"][summary_key]['osobni_auto_tyden'])+';'+str(summaries_dictionary["week"][summary_key]['dodavka_tyden'])+';'+str(summaries_dictionary["week"][summary_key]['nakladni_auto_tyden']) + ';'+str(summaries_dictionary["week"][summary_key]['nerozeznane_vozidlo_tyden']) + ';' + str(celkem_aut) + ';\n')
        
        with open(output_directory + filename[key] + '_mesic.csv', 'w') as newfile:
            #newfile.write(json.dumps(summaries_dictionary))    
            newfile.write("key;protismer_mesic;do_40_kmh_mesic;40_az_60_kmh_mesic;vice_nez_60_kmh_mesic;osobni_auto_mesic;dodavka_mesic;nakladni_auto_mesic;nerozeznane_vozidlo_mesic;auta_suma;\n")

            for summary_key in summaries_dictionary["month"]:
                celkem_aut = summaries_dictionary["month"][summary_key]['osobni_auto_mesic']+ summaries_dictionary["month"][summary_key]['dodavka_mesic']  + summaries_dictionary["month"][summary_key]['nakladni_auto_mesic'] + summaries_dictionary["month"][summary_key]['nerozeznane_vozidlo_mesic']
                newfile.write(summary_key[0:2]+'.'+';'+str(summaries_dictionary["month"][summary_key]['protismer_mesic'])+';'+str(summaries_dictionary["month"][summary_key]['do_40_kmh_mesic']) + ';'+str(summaries_dictionary["month"][summary_key]['40_az_60_kmh_mesic'])+';'+str(summaries_dictionary["month"][summary_key]['vice_nez_60_kmh_mesic'])+';'+str(summaries_dictionary["month"][summary_key]['osobni_auto_mesic'])+';'+str(summaries_dictionary["month"][summary_key]['dodavka_mesic'])+';'+str(summaries_dictionary["month"][summary_key]['nakladni_auto_mesic']) + ';'+str(summaries_dictionary["month"][summary_key]['nerozeznane_vozidlo_mesic']) + ';' + str(celkem_aut) + ';\n')

        
        den_preklad = {
            '0' : "Po",
            '1' : "Út",
            '2' : "St",
            '3' : "Čt",
            '4' : "Pá",
            '5' : "So",
            '6' : "Ne",
        }

        tyden_prujezdy = {
        }

        for day in summaries_dictionary["day"]:

            # print(day, json.dumps(summaries_dictionary["day"][day]["hour"]))

            day_date = datetime.datetime(2022, int(day[0:2]), int(day[4:6]))
            den_text = den_preklad[str(day_date.weekday())]
            if( (den_text + '_count') not in tyden_prujezdy):
                tyden_prujezdy[(den_text + '_count')] = 0
                tyden_prujezdy[(den_text + '_sums')] = {}
                tyden_prujezdy[(den_text + '_sums')]["index_in_day"]  = 0
                tyden_prujezdy[(den_text + '_sums')]["protismer_den"]  = 0
                tyden_prujezdy[(den_text + '_sums')]["do_40_kmh_den"]  = 0
                tyden_prujezdy[(den_text + '_sums')]["40_az_60_kmh_den"]  = 0
                tyden_prujezdy[(den_text + '_sums')]["vice_nez_60_kmh_den"]  = 0
                tyden_prujezdy[(den_text + '_sums')]["osobni_auto_den"]  = 0
                tyden_prujezdy[(den_text + '_sums')]["dodavka_den"]  = 0
                tyden_prujezdy[(den_text + '_sums')]["nakladni_auto_den"]  = 0
                tyden_prujezdy[(den_text + '_sums')]["nerozeznane_vozidlo_den"] = 0

            tyden_prujezdy[(den_text + '_count')] =  tyden_prujezdy[(den_text + '_count')] + 1

            tyden_prujezdy[(den_text + '_sums')]["index_in_day"]  = summaries_dictionary["day"][day ]['index_in_day'] + tyden_prujezdy[(den_text + '_sums')]["index_in_day"]
            tyden_prujezdy[(den_text + '_sums')]["protismer_den"]  = summaries_dictionary["day"][day ]['protismer_den'] + tyden_prujezdy[(den_text + '_sums')]["protismer_den"]
            tyden_prujezdy[(den_text + '_sums')]["do_40_kmh_den"]  = summaries_dictionary["day"][day ]['do_40_kmh_den'] + tyden_prujezdy[(den_text + '_sums')]["do_40_kmh_den"] 
            tyden_prujezdy[(den_text + '_sums')]["40_az_60_kmh_den"]  = summaries_dictionary["day"][day ]['40_az_60_kmh_den'] +  tyden_prujezdy[(den_text + '_sums')]["40_az_60_kmh_den"]
            tyden_prujezdy[(den_text + '_sums')]["vice_nez_60_kmh_den"]  = summaries_dictionary["day"][day ]['vice_nez_60_kmh_den'] + tyden_prujezdy[(den_text + '_sums')]["vice_nez_60_kmh_den"] 
            tyden_prujezdy[(den_text + '_sums')]["osobni_auto_den"]  = summaries_dictionary["day"][day ]['osobni_auto_den'] + tyden_prujezdy[(den_text + '_sums')]["osobni_auto_den"]
            tyden_prujezdy[(den_text + '_sums')]["dodavka_den"]  = summaries_dictionary["day"][day ]['dodavka_den'] + tyden_prujezdy[(den_text + '_sums')]["dodavka_den"]
            tyden_prujezdy[(den_text + '_sums')]["nakladni_auto_den"]  = summaries_dictionary["day"][day ]['nakladni_auto_den'] + tyden_prujezdy[(den_text + '_sums')]["nakladni_auto_den"]
            tyden_prujezdy[(den_text + '_sums')]["nerozeznane_vozidlo_den"] = summaries_dictionary["day"][day ]['nerozeznane_vozidlo_den']  + tyden_prujezdy[(den_text + '_sums')]["nerozeznane_vozidlo_den"]



        with open(output_directory + filename[key] + '_tyden_prumery.csv', 'w') as newfile:
            newfile.write("key;protismer_den;do_40_kmh_den;40_az_60_kmh_den;vice_nez_60_kmh_den;osobni_auto_den;dodavka_den;nakladni_auto_den;nerozeznane_vozidlo_den;auta_suma;\n")
            for day_key in den_preklad:
                if(den_preklad[day_key]  + '_sums' in tyden_prujezdy):
                    celkem_aut = (tyden_prujezdy[(den_preklad[day_key] + '_sums')]['osobni_auto_den']+ tyden_prujezdy[(den_preklad[day_key] + '_sums')]['dodavka_den']  + tyden_prujezdy[(den_preklad[day_key] + '_sums')]['nakladni_auto_den'] + tyden_prujezdy[(den_preklad[day_key] + '_sums')]['nerozeznane_vozidlo_den'])
                
                    newfile.write(den_preklad[day_key]+';'+str(round(tyden_prujezdy[(den_preklad[day_key] + '_sums')]['protismer_den']/tyden_prujezdy[(den_preklad[day_key] + '_count')],1))+';'+str(round(tyden_prujezdy[(den_preklad[day_key] + '_sums')]['do_40_kmh_den']/tyden_prujezdy[(den_preklad[day_key] + '_count')],1)) + ';'+str(round(tyden_prujezdy[(den_preklad[day_key] + '_sums')]['40_az_60_kmh_den']/tyden_prujezdy[(den_preklad[day_key] + '_count')],1))+';'+str(round(tyden_prujezdy[(den_preklad[day_key] + '_sums')]['vice_nez_60_kmh_den']/tyden_prujezdy[(den_preklad[day_key] + '_count')],1))+';'+str(round(tyden_prujezdy[(den_preklad[day_key] + '_sums')]['osobni_auto_den']/tyden_prujezdy[(den_preklad[day_key] + '_count')],1))+';'+str(round(tyden_prujezdy[(den_preklad[day_key] + '_sums')]['dodavka_den']/tyden_prujezdy[(den_preklad[day_key] + '_count')],1))+';'+str(round(tyden_prujezdy[(den_preklad[day_key] + '_sums')]['nakladni_auto_den']/tyden_prujezdy[(den_preklad[day_key] + '_count')],1)) + ';'+str(round(tyden_prujezdy[(den_preklad[day_key] + '_sums')]['nerozeznane_vozidlo_den']/tyden_prujezdy[(den_preklad[day_key] + '_count')],1)) + ';' + str(round(celkem_aut/tyden_prujezdy[(den_preklad[day_key] + '_count')],1)) + ';\n')

        tyden_hodiny = {
        }

        for day in summaries_dictionary["day"]:
            
            day_date = datetime.datetime(2022, int(day[0:2]), int(day[4:6]))
            den_text = den_preklad[str(day_date.weekday())]

            if(den_text not in tyden_hodiny):
                tyden_hodiny[den_text] = {}

            for hour in summaries_dictionary["day"][day]["hour"]:

                if((hour + '_count') not in tyden_hodiny[den_text]):
                    tyden_hodiny[den_text][hour + '_count'] = 0
                    tyden_hodiny[den_text][hour + '_sums'] = {
                        "protismer_hodina" : 0,
                        #"speed1_diff"
                        "do_40_kmh_hodina" : 0,
                        # "speed2_diff"
                        "40_az_60_kmh_hodina" : 0,
                        #"speed3_diff"
                        "vice_nez_60_kmh_hodina" : 0,
                        #"len0_diff"
                        "osobni_auto_hodina": 0,
                        #"len1_diff"
                        "dodavka_hodina": 0, 
                        #"len2_diff"
                        "nakladni_auto_hodina": 0,
                        #"len3_diff"
                        "nerozeznane_vozidlo_hodina" : 0
                    }
                
                tyden_hodiny[den_text][hour + '_count'] = tyden_hodiny[den_text][hour + '_count'] + 1

                tyden_hodiny[den_text][hour + '_sums']["protismer_hodina"] = tyden_hodiny[den_text][hour + '_sums']["protismer_hodina"] + summaries_dictionary["day"][day]["hour"][hour]["protismer_hodina"]
                tyden_hodiny[den_text][hour + '_sums']["do_40_kmh_hodina"]  =tyden_hodiny[den_text][hour + '_sums']["do_40_kmh_hodina"] + summaries_dictionary["day"][day]["hour"][hour]["do_40_kmh_hodina"]
                tyden_hodiny[den_text][hour + '_sums']["40_az_60_kmh_hodina"]  = tyden_hodiny[den_text][hour + '_sums']["40_az_60_kmh_hodina"] + summaries_dictionary["day"][day]["hour"][hour]["40_az_60_kmh_hodina"]
                tyden_hodiny[den_text][hour + '_sums']["vice_nez_60_kmh_hodina"]  = tyden_hodiny[den_text][hour + '_sums']["vice_nez_60_kmh_hodina"] + summaries_dictionary["day"][day]["hour"][hour]["vice_nez_60_kmh_hodina"]
                tyden_hodiny[den_text][hour + '_sums']["osobni_auto_hodina"]  = tyden_hodiny[den_text][hour + '_sums']["osobni_auto_hodina"] + summaries_dictionary["day"][day]["hour"][hour]["osobni_auto_hodina"]
                tyden_hodiny[den_text][hour + '_sums']["dodavka_hodina"]  = tyden_hodiny[den_text][hour + '_sums']["dodavka_hodina"] + summaries_dictionary["day"][day]["hour"][hour]["dodavka_hodina"]
                tyden_hodiny[den_text][hour + '_sums']["nakladni_auto_hodina"]  = tyden_hodiny[den_text][hour + '_sums']["nakladni_auto_hodina"] + summaries_dictionary["day"][day]["hour"][hour]["nakladni_auto_hodina"]
                tyden_hodiny[den_text][hour + '_sums']["nerozeznane_vozidlo_hodina"] = tyden_hodiny[den_text][hour + '_sums']["nerozeznane_vozidlo_hodina"] + summaries_dictionary["day"][day]["hour"][hour]["nerozeznane_vozidlo_hodina"]


        with open(output_directory + filename[key] + '_tyden_hodiny_prumer.csv', 'w') as newfile:
            newfile.write("key;protismer_hodina;do_40_kmh_hodina;40_az_60_kmh_hodina;vice_nez_60_kmh_hodina;osobni_auto_hodina;dodavka_hodina;nakladni_auto_hodina;nerozeznane_vozidlo_hodina;auta_suma;\n")

            for day_key in den_preklad:
                if((den_preklad[day_key]) in tyden_hodiny):
                    for hour_key in tyden_hodiny[den_preklad[day_key]]:
                        if('sums' in hour_key):

                            celkem_aut = tyden_hodiny[(den_preklad[day_key])][hour_key]['osobni_auto_hodina'] + tyden_hodiny[(den_preklad[day_key])][hour_key]['dodavka_hodina'] + tyden_hodiny[(den_preklad[day_key])][hour_key]['nakladni_auto_hodina'] + tyden_hodiny[(den_preklad[day_key])][hour_key]['nerozeznane_vozidlo_hodina']
                            newfile.write(
                                den_preklad[day_key]+ ':' + hour_key[0:2] +';'
                                +str(round( tyden_hodiny[(den_preklad[day_key])][hour_key]['protismer_hodina'] / tyden_hodiny[(den_preklad[day_key])][hour_key[0:3] + '_count']
                                    , 1)) + ';'
                                +str(round( tyden_hodiny[(den_preklad[day_key])][hour_key]['do_40_kmh_hodina'] / tyden_hodiny[(den_preklad[day_key])][hour_key[0:3] + '_count']
                                    , 1)) + ';'
                                +str(round( tyden_hodiny[(den_preklad[day_key])][hour_key]['40_az_60_kmh_hodina'] / tyden_hodiny[(den_preklad[day_key])][hour_key[0:3] + '_count']
                                    , 1)) + ';'
                                +str(round( tyden_hodiny[(den_preklad[day_key])][hour_key]['vice_nez_60_kmh_hodina'] / tyden_hodiny[(den_preklad[day_key])][hour_key[0:3] + '_count']
                                    , 1)) + ';'
                                +str(round( tyden_hodiny[(den_preklad[day_key])][hour_key]['osobni_auto_hodina'] / tyden_hodiny[(den_preklad[day_key])][hour_key[0:3] + '_count']
                                    , 1)) + ';'
                                +str(round( tyden_hodiny[(den_preklad[day_key])][hour_key]['dodavka_hodina'] / tyden_hodiny[(den_preklad[day_key])][hour_key[0:3] + '_count']
                                    , 1)) + ';'
                                +str(round( tyden_hodiny[(den_preklad[day_key])][hour_key]['nakladni_auto_hodina'] / tyden_hodiny[(den_preklad[day_key])][hour_key[0:3] + '_count']
                                    , 1)) + ';'
                                +str(round( tyden_hodiny[(den_preklad[day_key])][hour_key]['nerozeznane_vozidlo_hodina'] / tyden_hodiny[(den_preklad[day_key])][hour_key[0:3] + '_count']
                                    , 1)) + ';'
                                +str(round( celkem_aut / tyden_hodiny[(den_preklad[day_key])][hour_key[0:3] + '_count']
                                    , 1)) + ';'
                                +'\n'
                            )
        

# just calling the main function
if __name__ == "__main__":
    main()