

import flask
from flask import request, jsonify
from numpy import little_endian, number
import requests as rq
import json

from datetime import datetime

from utils import *
# VARIABLES
#
#

PORT_NUMBER = 50001

debug_mode = True

api_name = "/bajcarAPI"

# my API allowed logins
allowed_logins = {
    "bajcar" : "loratech123axiom",
}

entranceID = "0004a30b00f95816"
passageID = "0004a30b00f8ca27"
departureID = "0004a30b00f95348"


allowed_devEUIDs = {
    entranceID : "00a29076-b3f7-11ec-a6f3-d7a7381dbf58", 
    passageID : "c49a423e-b3f6-11ec-a6f3-d3e41a2241cd",
    departureID : "00a29075-b3f7-11ec-a6f3-3b9d73214814",
}

# OUTPUT API
output_url_part1 = "https://10.175.125.51:9105/api/v1/notifications/loratech/"
output_url_part2_entrance = "entrance"
output_url_part2_passage = "passage"
output_url_part2_departure = "departure"

ivisec_login = "bajcar"
ivisec_password = "X1+bc3*"

dev_eui_URL ={
    entranceID : output_url_part2_entrance,
    departureID : output_url_part2_departure, 
    passageID : output_url_part2_passage,
}

previous_requests = {
    entranceID : "NONE",
    departureID : "NONE", 
    passageID : "NONE",
}

# scope flask app variable
app = flask.Flask(__name__)
app.config["DEBUG"] = debug_mode

# function posting parsed data to URL
def postParsedData(url, dateTimeNow, dateTimePrevious, parsedDataNEW, parsedDataPrevious, elementID, login, password, summaries_dictionary):
# assignment of missing variables
    if('len0_speed0_cnt12' not in parsedDataNEW):
        parsedDataNEW['len0_speed0_cnt12'] = 0
    if('len0_speed1_cnt12' not in parsedDataNEW):
        parsedDataNEW['len0_speed1_cnt12'] = 0
    if('len0_speed2_cnt12' not in parsedDataNEW):
        parsedDataNEW['len0_speed2_cnt12'] = 0
    if('len0_speed3_cnt12' not in parsedDataNEW):
        parsedDataNEW['len0_speed3_cnt12'] = 0
    if('len1_speed0_cnt12' not in parsedDataNEW):
        parsedDataNEW['len1_speed0_cnt12'] = 0
    if('len1_speed1_cnt12' not in parsedDataNEW):
        parsedDataNEW['len1_speed1_cnt12'] = 0
    if('len1_speed2_cnt12' not in parsedDataNEW):
        parsedDataNEW['len1_speed2_cnt12'] = 0
    if('len1_speed3_cnt12' not in parsedDataNEW):
        parsedDataNEW['len1_speed3_cnt12'] = 0
    if('len2_speed0_cnt12' not in parsedDataNEW):
        parsedDataNEW['len2_speed0_cnt12'] = 0
    if('len2_speed1_cnt12' not in parsedDataNEW):
        parsedDataNEW['len2_speed1_cnt12'] = 0
    if('len2_speed2_cnt12' not in parsedDataNEW):
        parsedDataNEW['len2_speed2_cnt12'] = 0
    if('len2_speed3_cnt12' not in parsedDataNEW):
        parsedDataNEW['len2_speed3_cnt12'] = 0
    if('len3_cnt12' not in parsedDataNEW):
        parsedDataNEW['len3_cnt12'] = 0

    if('len0_speed0_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len0_speed0_cnt12'] = 0
    if('len0_speed1_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len0_speed1_cnt12'] = 0
    if('len0_speed2_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len0_speed2_cnt12'] = 0
    if('len0_speed3_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len0_speed3_cnt12'] = 0
    if('len1_speed0_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len1_speed0_cnt12'] = 0
    if('len1_speed1_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len1_speed1_cnt12'] = 0
    if('len1_speed2_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len1_speed2_cnt12'] = 0
    if('len1_speed3_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len1_speed3_cnt12'] = 0
    if('len2_speed0_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len2_speed0_cnt12'] = 0
    if('len2_speed1_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len2_speed1_cnt12'] = 0
    if('len2_speed2_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len2_speed2_cnt12'] = 0
    if('len2_speed3_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len2_speed3_cnt12'] = 0
    if('len3_cnt12' not in parsedDataPrevious):
        parsedDataPrevious['len3_cnt12'] = 0

    # repair of values IN CASE OF other value OWERFLOW
    if(parsedDataNEW['len0_speed0_cnt12'] < parsedDataPrevious['len0_speed0_cnt12']):
        parsedDataNEW['len0_speed0_cnt12'] = parsedDataNEW['len0_speed0_cnt12'] + 4096
    if(parsedDataNEW['len0_speed1_cnt12'] < parsedDataPrevious['len0_speed1_cnt12']):
        parsedDataNEW['len0_speed1_cnt12'] = parsedDataNEW['len0_speed1_cnt12'] + 4096
    if(parsedDataNEW['len0_speed2_cnt12'] < parsedDataPrevious['len0_speed2_cnt12']):
        parsedDataNEW['len0_speed2_cnt12'] = parsedDataNEW['len0_speed2_cnt12'] + 4096
    if(parsedDataNEW['len0_speed3_cnt12'] < parsedDataPrevious['len0_speed3_cnt12']):
        parsedDataNEW['len0_speed3_cnt12'] = parsedDataNEW['len0_speed3_cnt12'] + 4096

    if(parsedDataNEW['len1_speed0_cnt12'] < parsedDataPrevious['len1_speed0_cnt12']):
        parsedDataNEW['len1_speed0_cnt12'] = parsedDataNEW['len1_speed0_cnt12'] + 4096
    if(parsedDataNEW['len1_speed1_cnt12'] < parsedDataPrevious['len1_speed1_cnt12']):
        parsedDataNEW['len1_speed1_cnt12'] = parsedDataNEW['len1_speed1_cnt12'] + 4096
    if(parsedDataNEW['len1_speed2_cnt12'] < parsedDataPrevious['len1_speed2_cnt12']):
        parsedDataNEW['len1_speed2_cnt12'] = parsedDataNEW['len1_speed2_cnt12'] + 4096
    if(parsedDataNEW['len1_speed3_cnt12'] < parsedDataPrevious['len1_speed3_cnt12']):
        parsedDataNEW['len1_speed3_cnt12'] = parsedDataNEW['len1_speed3_cnt12'] + 4096

    if(parsedDataNEW['len2_speed0_cnt12'] < parsedDataPrevious['len2_speed0_cnt12']):
        parsedDataNEW['len2_speed0_cnt12'] = parsedDataNEW['len2_speed0_cnt12'] + 4096
    if(parsedDataNEW['len2_speed1_cnt12'] < parsedDataPrevious['len2_speed1_cnt12']):
        parsedDataNEW['len2_speed1_cnt12'] = parsedDataNEW['len2_speed1_cnt12'] + 4096
    if(parsedDataNEW['len2_speed2_cnt12'] < parsedDataPrevious['len2_speed2_cnt12']):
        parsedDataNEW['len2_speed2_cnt12'] = parsedDataNEW['len2_speed2_cnt12'] + 4096
    if(parsedDataNEW['len2_speed3_cnt12'] < parsedDataPrevious['len2_speed3_cnt12']):
        parsedDataNEW['len2_speed3_cnt12'] = parsedDataNEW['len2_speed3_cnt12'] + 4096

    if(parsedDataNEW['len3_cnt12'] < parsedDataPrevious['len3_cnt12']):
        parsedDataNEW['len3_cnt12'] = parsedDataNEW['len3_cnt12'] + 4096
    

    new_len0_count = - parsedDataNEW['len0_speed0_cnt12'] + parsedDataNEW['len0_speed1_cnt12'] + parsedDataNEW['len0_speed2_cnt12'] +parsedDataNEW['len0_speed3_cnt12']
    new_len1_count = - parsedDataNEW['len1_speed0_cnt12'] + parsedDataNEW['len1_speed1_cnt12'] + parsedDataNEW['len1_speed2_cnt12'] +parsedDataNEW['len1_speed3_cnt12']
    new_len2_count = - parsedDataNEW['len2_speed0_cnt12'] + parsedDataNEW['len2_speed1_cnt12'] + parsedDataNEW['len2_speed2_cnt12'] +parsedDataNEW['len2_speed3_cnt12']


    old_len0_count = - parsedDataPrevious['len0_speed0_cnt12'] + parsedDataPrevious['len0_speed1_cnt12'] + parsedDataPrevious['len0_speed2_cnt12'] +parsedDataPrevious['len0_speed3_cnt12']
    old_len1_count = - parsedDataPrevious['len1_speed0_cnt12'] + parsedDataPrevious['len1_speed1_cnt12'] + parsedDataPrevious['len1_speed2_cnt12'] +parsedDataPrevious['len1_speed3_cnt12']
    old_len2_count = - parsedDataPrevious['len2_speed0_cnt12'] + parsedDataPrevious['len2_speed1_cnt12'] + parsedDataPrevious['len2_speed2_cnt12'] +parsedDataPrevious['len2_speed3_cnt12']

    new_len3_count = parsedDataNEW['len3_cnt12']
    old_len3_count = parsedDataPrevious['len3_cnt12']

    new_speed0_count = parsedDataNEW['len0_speed0_cnt12'] + parsedDataNEW['len1_speed0_cnt12'] + parsedDataNEW['len2_speed0_cnt12'] +  parsedDataNEW['len3_cnt12']
    new_speed1_count = parsedDataNEW['len0_speed1_cnt12'] + parsedDataNEW['len1_speed1_cnt12'] + parsedDataNEW['len2_speed1_cnt12'] +  parsedDataNEW['len3_cnt12']
    new_speed2_count = parsedDataNEW['len0_speed2_cnt12'] + parsedDataNEW['len1_speed2_cnt12'] + parsedDataNEW['len2_speed2_cnt12'] +  parsedDataNEW['len3_cnt12']
    new_speed3_count = parsedDataNEW['len0_speed3_cnt12'] + parsedDataNEW['len1_speed3_cnt12'] + parsedDataNEW['len2_speed3_cnt12'] +  parsedDataNEW['len3_cnt12']

    old_speed0_count = parsedDataPrevious['len0_speed0_cnt12'] + parsedDataPrevious['len1_speed0_cnt12'] + parsedDataPrevious['len2_speed0_cnt12'] +  parsedDataPrevious['len3_cnt12']
    old_speed1_count = parsedDataPrevious['len0_speed1_cnt12'] + parsedDataPrevious['len1_speed1_cnt12'] + parsedDataPrevious['len2_speed1_cnt12'] +  parsedDataPrevious['len3_cnt12']
    old_speed2_count = parsedDataPrevious['len0_speed2_cnt12'] + parsedDataPrevious['len1_speed2_cnt12'] + parsedDataPrevious['len2_speed2_cnt12'] +  parsedDataPrevious['len3_cnt12']
    old_speed3_count = parsedDataPrevious['len0_speed3_cnt12'] + parsedDataPrevious['len1_speed3_cnt12'] + parsedDataPrevious['len2_speed3_cnt12'] +  parsedDataPrevious['len3_cnt12']

    year_string = dateTimeNow[0:4]
    day_string = dateTimeNow[8:10]
    hour_string = dateTimeNow[11:13]
    month_string = dateTimeNow[5:7]
    week_string = week_number_of_month(int(day_string),int(month_string), int(year_string))
    
    day_key = "%sm_%sd" % (month_string, day_string) 
    week_key = "%sw" % (week_string) 
    month_key = ("%sm" % (month_string))  
    hour_key = "%sh" % (hour_string) 


    if(day_key not in summaries_dictionary["day"]):
        summaries_dictionary["day"][day_key] = {

                "hour" : {},

                "index_in_day" : 0,
                #"speed0_diff"
                "protismer_den" : 0,
                #"speed1_diff"
                "do_40_kmh_den" : 0,
                # "speed2_diff"
                "40_az_60_kmh_den" : 0,
                #"speed3_diff"
                "vice_nez_60_kmh_den" : 0,
                #"len0_diff"
                "osobni_auto_den": 0,
                #"len1_diff"
                "dodavka_den": 0, 
                #"len2_diff"
                "nakladni_auto_den": 0,
                #"len3_diff"
                "nerozeznane_vozidlo_den" : 0
        }
    if(hour_key not in summaries_dictionary["day"][day_key]["hour"]):
        summaries_dictionary["day"][day_key]["hour"][hour_key] = {
                "index_in_hour" : 0,
                #"speed0_diff"
                "protismer_hodina" : 0,
                #"speed1_diff"
                "do_40_kmh_hodina" : 0,
                # "speed2_diff"
                "40_az_60_kmh_hodina" : 0,
                #"speed3_diff"
                "vice_nez_60_kmh_hodina" : 0,
                #"len0_diff"
                "osobni_auto_hodina": 0,
                #"len1_diff"
                "dodavka_hodina": 0, 
                #"len2_diff"
                "nakladni_auto_hodina": 0,
                #"len3_diff"
                "nerozeznane_vozidlo_hodina" : 0
        }

    if(week_key not in summaries_dictionary["week"]):
        summaries_dictionary["week"][week_key] =  {
                "index_in_week" : 0,
                #"speed0_diff"
                "protismer_tyden" : 0,
                #"speed1_diff"
                "do_40_kmh_tyden" : 0,
                # "speed2_diff"
                "40_az_60_kmh_tyden" : 0,
                #"speed3_diff"
                "vice_nez_60_kmh_tyden" : 0,
                #"len0_diff"
                "osobni_auto_tyden": 0,
                #"len1_diff"
                "dodavka_tyden": 0, 
                #"len2_diff"
                "nakladni_auto_tyden": 0,
                #"len3_diff"
                "nerozeznane_vozidlo_tyden" : 0
        }
    if(month_key not in summaries_dictionary["month"]):
        summaries_dictionary["month"][month_key] =  {
                "index_in_month" : 0,
                #"speed0_diff"
                "protismer_mesic" : 0,
                #"speed1_diff"
                "do_40_kmh_mesic" : 0,
                # "speed2_diff"
                "40_az_60_kmh_mesic" : 0,
                #"speed3_diff"
                "vice_nez_60_kmh_mesic" : 0,
                #"len0_diff"
                "osobni_auto_mesic": 0,
                #"len1_diff"
                "dodavka_mesic": 0, 
                #"len2_diff"
                "nakladni_auto_mesic": 0,
                #"len3_diff"
                "nerozeznane_vozidlo_mesic" : 0
        }

    # data object
    data = {
        "elemId" : elementID,
        "stime": dateTimeNow,
        "data": {

             ### TIME RANGE:
                "time_range_begin" : dateTimePrevious,
                "time_range_end" : dateTimeNow,

                #"speed0_diff"
                "protismer" : new_speed0_count - old_speed0_count,
                #"speed1_diff"
                "do_40_kmh" : new_speed1_count - old_speed1_count,
                # "speed2_diff"
                "40_az_60_kmh" : new_speed2_count - old_speed2_count,
                #"speed3_diff"
                "vice_nez_60_kmh" : new_speed3_count - old_speed3_count,
                #"len0_diff"
                "osobni_auto": new_len0_count - old_len0_count,
                #"len1_diff"
                "dodavka": new_len1_count - old_len1_count, 
                #"len2_diff"
                "nakladni_auto": new_len2_count - old_len2_count,
                #"len3_diff"
                "nerozeznane_vozidlo" : new_len3_count - old_len3_count, 

            ### tento den sum:
                "index_in_day" : summaries_dictionary["day"][day_key]["index_in_day"] + 1,

                #"speed0_diff"
                "protismer_den" : summaries_dictionary["day"][day_key]["protismer_den"] + (new_speed0_count - old_speed0_count),
                #"speed1_diff"
                "do_40_kmh_den" : summaries_dictionary["day"][day_key]["do_40_kmh_den"] + (new_speed1_count - old_speed1_count),
                # "speed2_diff"
                "40_az_60_kmh_den" : summaries_dictionary["day"][day_key]["40_az_60_kmh_den"] + (new_speed2_count - old_speed2_count),
                #"speed3_diff"
                "vice_nez_60_kmh_den" : summaries_dictionary["day"][day_key]["vice_nez_60_kmh_den"] + (new_speed3_count - old_speed3_count),
                #"len0_diff"
                "osobni_auto_den": summaries_dictionary["day"][day_key]["osobni_auto_den"] + (new_len0_count - old_len0_count),
                #"len1_diff"
                "dodavka_den": summaries_dictionary["day"][day_key]["dodavka_den"] + (new_len1_count - old_len1_count), 
                #"len2_diff"
                "nakladni_auto_den": summaries_dictionary["day"][day_key]["nakladni_auto_den"] + (new_len2_count - old_len2_count),
                #"len3_diff"
                "nerozeznane_vozidlo_den" : summaries_dictionary["day"][day_key]["nerozeznane_vozidlo_den"] + (new_len3_count - old_len3_count), 

                "index_in_day" : summaries_dictionary["day"][day_key]["index_in_day"] + 1,

                #"speed0_diff"

                "index_in_hour" : summaries_dictionary["day"][day_key]["hour"][hour_key]["index_in_hour"] + 1,

                "protismer_hodina" : summaries_dictionary["day"][day_key]["hour"][hour_key]["protismer_hodina"] + (new_speed0_count - old_speed0_count),
                #"speed1_diff"
                "do_40_kmh_hodina" : summaries_dictionary["day"][day_key]["hour"][hour_key]["do_40_kmh_hodina"] + (new_speed1_count - old_speed1_count),
                # "speed2_diff"
                "40_az_60_kmh_hodina" : summaries_dictionary["day"][day_key]["hour"][hour_key]["40_az_60_kmh_hodina"] + (new_speed2_count - old_speed2_count),
                #"speed3_diff"
                "vice_nez_60_kmh_hodina" : summaries_dictionary["day"][day_key]["hour"][hour_key]["vice_nez_60_kmh_hodina"] + (new_speed3_count - old_speed3_count),
                #"len0_diff"
                "osobni_auto_hodina": summaries_dictionary["day"][day_key]["hour"][hour_key]["osobni_auto_hodina"] + (new_len0_count - old_len0_count),
                #"len1_diff"
                "dodavka_hodina": summaries_dictionary["day"][day_key]["hour"][hour_key]["dodavka_hodina"] + (new_len1_count - old_len1_count), 
                #"len2_diff"
                "nakladni_auto_hodina": summaries_dictionary["day"][day_key]["hour"][hour_key]["nakladni_auto_hodina"] + (new_len2_count - old_len2_count),
                #"len3_diff"
                "nerozeznane_vozidlo_hodina" : summaries_dictionary["day"][day_key]["hour"][hour_key]["nerozeznane_vozidlo_hodina"] + (new_len3_count - old_len3_count), 

            ### tento tyden sum:
                "index_in_week" : summaries_dictionary["week"][week_key]["index_in_week"] + 1,

                #"speed0_diff"
                "protismer_tyden" : summaries_dictionary["week"][week_key]["protismer_tyden"] + (new_speed0_count - old_speed0_count),
                #"speed1_diff"
                "do_40_kmh_tyden" : summaries_dictionary["week"][week_key]["do_40_kmh_tyden"] + (new_speed1_count - old_speed1_count),
                # "speed2_diff"
                "40_az_60_kmh_tyden" : summaries_dictionary["week"][week_key]["40_az_60_kmh_tyden"] + (new_speed2_count - old_speed2_count),
                #"speed3_diff"
                "vice_nez_60_kmh_tyden" : summaries_dictionary["week"][week_key]["vice_nez_60_kmh_tyden"] + (new_speed3_count - old_speed3_count),
                #"len0_diff"
                "osobni_auto_tyden": summaries_dictionary["week"][week_key]["osobni_auto_tyden"] + (new_len0_count - old_len0_count),
                #"len1_diff"
                "dodavka_tyden": summaries_dictionary["week"][week_key]["dodavka_tyden"] + (new_len1_count - old_len1_count), 
                #"len2_diff"
                "nakladni_auto_tyden": summaries_dictionary["week"][week_key]["nakladni_auto_tyden"] + (new_len2_count - old_len2_count),
                #"len3_diff"
                "nerozeznane_vozidlo_tyden" : summaries_dictionary["week"][week_key]["nerozeznane_vozidlo_tyden"] + (new_len3_count - old_len3_count), 

            ### tento mesic sum:
                "index_in_month" :  summaries_dictionary["month"][month_key]["index_in_month"] + 1,

                #"speed0_diff"
                "protismer_mesic" : summaries_dictionary["month"][month_key]["protismer_mesic"] + (new_speed0_count - old_speed0_count),
                #"speed1_diff"
                "do_40_kmh_mesic" : summaries_dictionary["month"][month_key]["do_40_kmh_mesic"] + (new_speed1_count - old_speed1_count),
                # "speed2_diff"
                "40_az_60_kmh_mesic" : summaries_dictionary["month"][month_key]["40_az_60_kmh_mesic"] + (new_speed2_count - old_speed2_count),
                #"speed3_diff"
                "vice_nez_60_kmh_mesic" : summaries_dictionary["month"][month_key]["vice_nez_60_kmh_mesic"] + (new_speed3_count - old_speed3_count),
                #"len0_diff"
                "osobni_auto_mesic": summaries_dictionary["month"][month_key]["osobni_auto_mesic"] + (new_len0_count - old_len0_count),
                #"len1_diff"
                "dodavka_mesic": summaries_dictionary["month"][month_key]["dodavka_mesic"] + (new_len1_count - old_len1_count), 
                #"len2_diff"
                "nakladni_auto_mesic": summaries_dictionary["month"][month_key]["nakladni_auto_mesic"] + (new_len2_count - old_len2_count),
                #"len3_diff"
                "nerozeznane_vozidlo_mesic" :  summaries_dictionary["month"][month_key]["nerozeznane_vozidlo_mesic"] + (new_len3_count - old_len3_count), 

                },
        "desc": "parkoviště FEL v.2"
    }

    summaries_dictionary["day"][day_key]["index_in_day"]  = data['data']['index_in_day']
    summaries_dictionary["day"][day_key]["protismer_den"]  = data['data']['protismer_den']
    summaries_dictionary["day"][day_key]["do_40_kmh_den"]  = data['data']['do_40_kmh_den']
    summaries_dictionary["day"][day_key]["40_az_60_kmh_den"]  = data['data']['40_az_60_kmh_den']
    summaries_dictionary["day"][day_key]["vice_nez_60_kmh_den"]  = data['data']['vice_nez_60_kmh_den']
    summaries_dictionary["day"][day_key]["osobni_auto_den"]  = data['data']['osobni_auto_den']
    summaries_dictionary["day"][day_key]["dodavka_den"]  = data['data']['dodavka_den']
    summaries_dictionary["day"][day_key]["nakladni_auto_den"]  = data['data']['nakladni_auto_den']
    summaries_dictionary["day"][day_key]["nerozeznane_vozidlo_den"] = data['data']['nerozeznane_vozidlo_den']

    # hours:
    summaries_dictionary["day"][day_key]["hour"][hour_key]["protismer_hodina"]  = data['data']['protismer_hodina']
    summaries_dictionary["day"][day_key]["hour"][hour_key]["do_40_kmh_hodina"]  = data['data']['do_40_kmh_hodina']
    summaries_dictionary["day"][day_key]["hour"][hour_key]["40_az_60_kmh_hodina"]  = data['data']['40_az_60_kmh_hodina']
    summaries_dictionary["day"][day_key]["hour"][hour_key]["vice_nez_60_kmh_hodina"]  = data['data']['vice_nez_60_kmh_hodina']
    summaries_dictionary["day"][day_key]["hour"][hour_key]["osobni_auto_hodina"]  = data['data']['osobni_auto_hodina']
    summaries_dictionary["day"][day_key]["hour"][hour_key]["dodavka_hodina"]  = data['data']['dodavka_hodina']
    summaries_dictionary["day"][day_key]["hour"][hour_key]["nakladni_auto_hodina"]  = data['data']['nakladni_auto_hodina']
    summaries_dictionary["day"][day_key]["hour"][hour_key]["nerozeznane_vozidlo_hodina"] = data['data']['nerozeznane_vozidlo_hodina']

    summaries_dictionary["week"][week_key]["index_in_week"]  = data['data']['index_in_week']
    summaries_dictionary["week"][week_key]["protismer_tyden"]  = data['data']['protismer_tyden']
    summaries_dictionary["week"][week_key]["do_40_kmh_tyden"]  = data['data']['do_40_kmh_tyden']
    summaries_dictionary["week"][week_key]["40_az_60_kmh_tyden"]  = data['data']['40_az_60_kmh_tyden']
    summaries_dictionary["week"][week_key]["vice_nez_60_kmh_tyden"]  = data['data']['vice_nez_60_kmh_tyden']
    summaries_dictionary["week"][week_key]["osobni_auto_tyden"]  = data['data']['osobni_auto_tyden']
    summaries_dictionary["week"][week_key]["dodavka_tyden"]  = data['data']['dodavka_tyden']
    summaries_dictionary["week"][week_key]["nakladni_auto_tyden"]  = data['data']['nakladni_auto_tyden']
    summaries_dictionary["week"][week_key]["nerozeznane_vozidlo_tyden"] = data['data']['nerozeznane_vozidlo_tyden']

    summaries_dictionary["month"][month_key]["index_in_month"]  = data['data']['index_in_month']
    summaries_dictionary["month"][month_key]["protismer_mesic"]  = data['data']['protismer_mesic']
    summaries_dictionary["month"][month_key]["do_40_kmh_mesic"]  = data['data']['do_40_kmh_mesic']
    summaries_dictionary["month"][month_key]["40_az_60_kmh_mesic"]  = data['data']['40_az_60_kmh_mesic']
    summaries_dictionary["month"][month_key]["vice_nez_60_kmh_mesic"]  = data['data']['vice_nez_60_kmh_mesic']
    summaries_dictionary["month"][month_key]["osobni_auto_mesic"]  = data['data']['osobni_auto_mesic']
    summaries_dictionary["month"][month_key]["dodavka_mesic"]  = data['data']['dodavka_mesic']
    summaries_dictionary["month"][month_key]["nakladni_auto_mesic"]  = data['data']['nakladni_auto_mesic']
    summaries_dictionary["month"][month_key]["nerozeznane_vozidlo_mesic"] = data['data']['nerozeznane_vozidlo_mesic']

    request = rq.post(url, data = json.dumps(data), verify=False, auth=(login, password), headers={'Content-Type' : 'application/json'})#, verify=path_to_certificate)  

    try:
        return { "text" : request.text, "code" : request.status_code}
    except Exception as e:
        print(e)
        return { "text" : "INVALID", "code" : 400}
        
def parseTimeStamp(timeStamp):
    dateTime = str(datetime.fromtimestamp(int(timeStamp)))
    return dateTime[:10] + "T" + dateTime[11:]

# validation of dateTime string
def isValidDateTimeString(time_string):
    if(len(time_string) == 19):
        return True
    return False



summaries_dictionary = {
            "day" : {},
            "week" : {},
            "month" : {},
        }

#          endpoint with EUID           POST METHOD ONLY
@app.route(api_name + '/data/<dev_euid>', methods=['POST'])
def post_data(dev_euid):

    # try:
    # check valid endpoint EUID
    if(dev_euid not in allowed_devEUIDs):
        if(debug_mode):
            print("DEBUG: unknown DEV_EUID")
        response = app.response_class(response='{"error" : "Unknown DEV_EUID"}',
                                status=401,
                                mimetype='application/json')
        return response

    # validate received login / password
    if(request.json['login'] not in allowed_logins or allowed_logins[request.json['login']] != request.json['password']):
        if(debug_mode):
            print("DEBUG: authorization fail")
        response = app.response_class(response='{"error" : "Authorization fail"}',
                                status=402,
                                mimetype='application/json')
        return response

    if(not isValidDateTimeString(request.json['time'])):
        # is TimeStamp?
        try:
            request.json['time'] = parseTimeStamp(request.json['time'])
        except:
            if(debug_mode):
                print("DEBUG: invalid time value")
            response = app.response_class(response='{"error" : "\'time\' : invalid value}"',
                                status=403,
                                mimetype='application/json')
            return response
    
    parsedData = parseData(request.json['payload'])

    if(parsedData['part'] != 1):
        if(debug_mode):
            print("DEBUG: not part 1 data")
        response = app.response_class(response='{"fail" : "Data not a part 1 type of data, not sending to AXIOM"}',
                                status=301,
                                mimetype='application/json')
        return response
    
    # is first request that came 
    # -> dont have two to compare to post the difference to axiom
    if(previous_requests[dev_euid] == "NONE"):
        previous_requests[dev_euid] = {"time" :  request.json['time'], "payload" :  request.json['payload']}
        if(debug_mode):
            print("DEBUG: first entry loaded")
        response = app.response_class(response='{"success" : "First data-entry loaded to API"}',
                                status=200,
                                mimetype='application/json')
        return response

    # data ok -> posting to axiom
    response = postParsedData(output_url_part1 + dev_eui_URL[dev_euid], request.json['time'], previous_requests[dev_euid]['time'], 
        parseData(request.json['payload']), parseData(previous_requests[dev_euid]['payload']), allowed_devEUIDs[dev_euid], ivisec_login, ivisec_password, summaries_dictionary
        )


    previous_requests[dev_euid] = {"time" :  request.json['time'], "payload" :  request.json['payload']}

    # response from axiom OK
    if(response["code"] < 400):
        if(debug_mode):
            print("DEBUG: call to AXIOM success, response: ", response['text'])
        response = app.response_class(response='{"success" : "Posted last two entries difference to API: ' + response['text'] + '"}',
                                status=201,
                                mimetype='application/json')
        return response
    else:
        if(debug_mode):
            print("DEBUG: callback to axiom failed. ", response["code"], " : ", response["text"])
        response = app.response_class(response='{"fail" : "Callback to AXIOM failed: ' + response["text"] + '"}',
                                status=500,
                                mimetype='application/json')
        return response

    # except Exception as e:
    #     print(e)
    #     if(debug_mode):
    #             print("DEBUG: invalid JSON string")
    #     response = app.response_class(response='{"error" : "Invalid JSON string"}',
    #                               status=500,
    #                               mimetype='application/json')
    #     return response
   

   

# main function
def main():
    app.run(port=PORT_NUMBER)

# just calling the main function
if __name__ == "__main__":
    main()

